package cours09;

import java.lang.reflect.Method;
import cours06.ListeBlocD;
import cours06.ListeBlocI;

public class GeneriqueI {

	
	public static boolean egalite(Class bI, Object o1, Object o2) {
		
		Boolean res = null;
		try {
			Class[] tc = new Class[2];
			tc[0] = o1.getClass();
			tc[1] = o2.getClass();
			Method m = bI.getMethod("egalite", tc);

			Object[] to = new Object[2];
			to[0] = o1;
			to[1] = o2;
			res = (Boolean)m.invoke(null, to);
		} catch (Exception e) {
			System.out.println("méthode inconnue");
		}
		return res.booleanValue();
	}
	
	public static boolean ordre(Class bI, Object o1, Object o2) {

		Boolean res = null;;
		try {
			Class[] tc = new Class[2];
			tc[0] = o1.getClass();
			tc[1] = o2.getClass();
			Method m = bI.getMethod("ordre", tc);

			Object[] to = new Object[2];
			to[0] = o1;
			to[1] = o2;
			res = (Boolean)m.invoke(null, to);
		} catch (Exception e) {
			System.out.println("méthode inconnue");
		}
		return res.booleanValue();
	}
	
	/* recherche naive d'une sous-liste dans une liste */
	public static int recherche(ListeBlocD p, ListeBlocD s) {
	
		int lp = ListeBlocI.longueur(p);
		int ls = ListeBlocI.longueur(s);
		int i, j = 0;
		for (i = 0;i < ls-lp;i++) {
			for (j = 0;j < lp;j++) {
				if (egalite(p.bI, ListeBlocI.lire(p, j), ListeBlocI.lire(s,i+j)) == false)
					break;
			}
			if (j == lp) break;
		}
		if (j == lp) return i;
		else return -1;
	}
	
	/* recherche KMP d'une sous-liste dans une liste */
	public static int rechercheKMP(ListeBlocD p, ListeBlocD s) {
		//votre code

	}
	
}
